package com.api

import java.text.SimpleDateFormat
import com.kms.katalon.core.annotation.Keyword
import com.kms.katalon.core.util.KeywordUtil




public class Gen {
	/**
	 * Receive Username and user object for validation of API response
	 * @param Username (String)
	 * @return UserObject
	 */

	@Keyword
	def getUserObject(String username){
		def SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'")
		def Map<String, Object> userObject = new HashMap<String, Object>();

		def dbURL = 'ipAddress'
		def dbPort =  '6700'
		def dbUsername = 'usrm'
		def dbPassword = 'usrm.pswd'
		def dbName = 'domainName'

		def sql_Server = new com.database.sqlServer()
		def userAcctStatus
		def userFeedbackNumber
		def userOptNumber
		def userFeedbackCount
		def userRegDate
		def userAge
		def isUserOver21
		def userAcctFlags

<columnName>
		sql_Server.connectDB(dbURL, dbPort, dbName, dbUsername, dbPassword)

		def userDetails = sql_Server.executeQuery('''
			SELECT u.<columnName>, u.<columnName>, u.<columnName>, u.<columnName>, u.<columnName>, u.<columnName>, u.<columnName>, u.<columnName> 
			  FROM <tablename> u
			  LEFT JOIN <tablename>b on b.<columnName> = u.<columnName>
			 WHERE u.<columnName> = \''''
				+ <variable> +
				'''\'
			''')

		if (userDetails.next() == false) {
			KeywordUtil.markErrorAndStop('@@@@ Error: There is something wrong with the getUserObject database query')
		}
		else {
			userAcctStatus = userDetails.getInt(1)
			userFeedbackNumber = userDetails.getFloat(2)
			userOptNumber = userDetails.getInt(3)
			userFeedbackCount = userDetails.getString(4)
			userRegDate = userDetails.getTimestamp(5)
			userAge = userDetails.getInt(6)
			isUserOver21 = false
			if(userAge > 21){
				isUserOver21 = true
			}
			userAcctFlags = userDetails.getInt(7)
		}

		sql_Server.closeDatabaseConnection()

		//set registration date to UTC
		sdf.setTimeZone(TimeZone.getTimeZone("UTC"))
		userRegDate = sdf.format(userRegDate)


		userObject.put('acctStatus', userAcctStatus)
		userObject.put('feedbackNumber', userFeedbackNumber)
		userObject.put('optionsNumber', userOptNumber)
		userObject.put('feedbackCount',userFeedbackCount)
		userObject.put('registrationDate', userRegDate)
		userObject.put('isUserOver21', isUserOver21)
		userObject.put('userAcctFlags', userAcctFlags)

		return userObject;
	}

	/**
	 * Receive UserID, Boolean showing if ID is buyer or seller, date limit and additional query filter to get random order record
	 * @param UserID (String)
	 * @param isSellerID (Boolean)
	 * @param orderDateLimit (Date)
	 * @param queryFilter (String)
	 * @return OrderObject
	 **/

	@Keyword
	def getOrderObject(Object userID, Boolean isSellerID,  Integer dateDifference, String queryFilter){

		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'")
		def Map<String, Object> orderObject = new LinkedHashMap<String, Object>();

		def dbURL = 'ipAddress'
		def dbPort =  '6700'
		def dbUsername = 'usrm'
		def dbPassword = 'usrm.pswd'
		def dbName = 'domainName'
		def sql_Server = new com.database.sqlServer()


		def buyerOrSeller = 'o.buyerID = '
		if(isSellerID == true) {
			buyerOrSeller = 'o.sellerID = '
		}

		def orderQuery = '''
				SELECT <table columns> 
		  FROM <tablename> o
		  JOIN <tablename>oi on oi.<columnName> = o.<columnName>
		  JOIN <tablename>ia on ia.<columnName> = oi.<columnName>
		 WHERE o.Status not in (8,9)
		   AND <columnName> > DATEADD(DAY, ''' + dateDifference + ''', GETDATE())
		   AND ''' + buyerOrSeller + userID + ' ' + queryFilter + '''
		 ORDER BY NEWID()
'''

		sql_Server.connectDB(dbURL, dbPort, dbName, dbUsername, dbPassword)

		def orderDetails = sql_Server.executeQuery(orderQuery)

		if (orderDetails.next() == false) {
			KeywordUtil.markErrorAndStop('@@@@ Error: Orders query returned no rows. Check query parameters')
		}


		def orderID = orderDetails.getString(1)
		def buyerID = orderDetails.getString(2)
		def sellerID = orderDetails.getString(3)
		def status = orderDetails.getInt(4)
		def fflNumber = orderDetails.getString(5)
		def isItemInsured = orderDetails.getBoolean(6)
		def couponID = orderDetails.getString(7)
		def couponCode = orderDetails.getString(8)
		def couponValue = orderDetails.getBigDecimal(9)
		if(couponValue == null) {
			couponValue = 0.0
		}
		else {
			couponValue = couponValue.setScale(2, BigDecimal.ROUND_HALF_UP)
		}
		def shipCarrier = orderDetails.getInt(10)
		def shipFromCompany = orderDetails.getString(11)
		def shipToVerified = orderDetails.getInt(12)
		def shipClass = orderDetails.getInt(13)
		def taxCloudCartID = orderDetails.getString(14)
		def miscDesc = orderDetails.getString(15)
		def paymentMethod = orderDetails.getInt(16)

		def billToName = orderDetails.getString(17)
		def billToAddress1 = orderDetails.getString(18)
		def billToAddress2 = orderDetails.getString(19)
		def billToCity = orderDetails.getString(20)
		def billToState = orderDetails.getString(21)
		def billToPostalCode = orderDetails.getString(22)
		def billToCountryCode = orderDetails.getString(23)
		def billToPhone = orderDetails.getString(24)
		def billToEmail = orderDetails.getString(25)
		def shipToName = orderDetails.getString(26)
		def shipToAddress1 = orderDetails.getString(27)
		def shipToAddress2 = orderDetails.getString(28)
		def shipToCity = orderDetails.getString(29)
		def shipToState = orderDetails.getString(30)
		def shipToPostalCode = orderDetails.getString(31)
		def shipToCountryCode = orderDetails.getString(32)
		def shipToPhone = orderDetails.getString(33)
		def shipToEmail = orderDetails.getString(34)
		def shipFromName = orderDetails.getString(35)
		def shipFromAddress1 = orderDetails.getString(36)
		def shipFromAddress2 = orderDetails.getString(37)
		def shipFromCity = orderDetails.getString(38)
		def shipFromState = orderDetails.getString(39)
		def shipFromPostalCode = orderDetails.getString(40)
		def shipFromCountryCode = orderDetails.getString(41)
		def shipFromPhone = orderDetails.getString(42)
		def shipFromEmail = orderDetails.getString(43)

		def shipCost = orderDetails.getBigDecimal(44)
		if(shipCost != null) {
			shipCost = shipCost.setScale(2, BigDecimal.ROUND_HALF_UP)
		}

		def shipHandlingCost = orderDetails.getBigDecimal(45)
		if(shipHandlingCost != null) {
			shipHandlingCost = shipHandlingCost.setScale(2, BigDecimal.ROUND_HALF_UP)
		}

		def shipInsuranceCost = orderDetails.getBigDecimal(46)
		if(shipInsuranceCost != null) {
			shipInsuranceCost = shipInsuranceCost.setScale(2, BigDecimal.ROUND_HALF_UP)
		}

		def orderTotal = orderDetails.getBigDecimal(47).setScale(2, BigDecimal.ROUND_HALF_UP)
		def ccUpChargePercent = orderDetails.getBigDecimal(48).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxShipping = orderDetails.getBigDecimal(49).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxInsurance = orderDetails.getBigDecimal(50).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxMisc = orderDetails.getBigDecimal(51).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxShippingTotal = orderDetails.getBigDecimal(52).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxHandlingTotal = orderDetails.getBigDecimal(53).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxMiscTotal = orderDetails.getBigDecimal(54).setScale(2, BigDecimal.ROUND_HALF_UP)
		def cashDiscTotal = orderDetails.getBigDecimal(55).setScale(2, BigDecimal.ROUND_HALF_UP)
		def complianceFee = orderDetails.getBigDecimal(56).setScale(2, BigDecimal.ROUND_HALF_UP)
		def miscCharge = orderDetails.getBigDecimal(57)
		if(miscCharge != null) {
			miscCharge = miscCharge.setScale(2, BigDecimal.ROUND_HALF_UP)
		}

		def orderDate = orderDetails.getTimestamp(58).format("yyyy-MM-dd'T'HH:mm:ss")
		def orderDateUTC = orderDetails.getTimestamp(58).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))

		def cancelDate = orderDetails.getTimestamp(59)
		def cancelDateUTC
		if(cancelDate != null) {
			cancelDate = cancelDate.format("yyyy-MM-dd'T'HH:mm:ss")
			cancelDateUTC = orderDetails.getTimestamp(59).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def layawayAcceptanceDate = orderDetails.getTimestamp(60)
		def layawayAcceptanceDateUTC
		if(layawayAcceptanceDate != null) {
			layawayAcceptanceDate = layawayAcceptanceDate.format("yyyy-MM-dd'T'HH:mm:ss")
			layawayAcceptanceDateUTC = orderDetails.getTimestamp(60).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def sellerReviewDate = orderDetails.getTimestamp(61)
		def sellerReviewDateUTC
		if(sellerReviewDate != null) {
			sellerReviewDate = sellerReviewDate.format("yyyy-MM-dd'T'HH:mm:ss")
			sellerReviewDateUTC = orderDetails.getTimestamp(61).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def buyerConfirmationDate = orderDetails.getTimestamp(62)
		def buyerConfirmationDateUTC
		if(buyerConfirmationDate != null) {
			buyerConfirmationDate = buyerConfirmationDate.format("yyyy-MM-dd'T'HH:mm:ss")
			buyerConfirmationDateUTC = orderDetails.getTimestamp(62).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def paymentReceivedDate = orderDetails.getTimestamp(63)
		def paymentReceivedDateUTC
		if(paymentReceivedDate != null) {
			paymentReceivedDate = paymentReceivedDate.format("yyyy-MM-dd'T'HH:mm:ss")
			paymentReceivedDateUTC = orderDetails.getTimestamp(63).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def fflReceivedDate = orderDetails.getTimestamp(64)
		def fflReceivedDateUTC
		if(fflReceivedDate != null) {
			fflReceivedDateUTC = fflReceivedDateUTC.format("yyyy-MM-dd'T'HH:mm:ss")
			fflReceivedDateUTC = orderDetails.getTimestamp(64).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def shipDate = orderDetails.getTimestamp(65)
		def shipDateUTC
		if(shipDate != null) {
			shipDate = shipDate.format("yyyy-MM-dd'T'HH:mm:ss")
			shipDateUTC = orderDetails.getTimestamp(65).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def paymentInProcessDate = orderDetails.getTimestamp(66)
		def paymentInProcessDateUTC
		if(paymentInProcessDate != null) {
			paymentInProcessDate = paymentInProcessDate.format("yyyy-MM-dd'T'HH:mm:ss")
			paymentInProcessDateUTC = orderDetails.getTimestamp(66).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def returnedDate = orderDetails.getTimestamp(67)
		def returnedDateUTC
		if(returnedDate != null) {
			returnedDate = returnedDate.format("yyyy-MM-dd'T'HH:mm:ss")
			returnedDateUTC = returnedDate.format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def buyerReviewedDate = orderDetails.getTimestamp(68)
		def buyerReviewedDateUTC
		if(buyerReviewedDate != null) {
			buyerReviewedDate = buyerReviewedDate.format("yyyy-MM-dd'T'HH:mm:ss")
			buyerReviewedDateUTC = orderDetails.getTimestamp(68).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def sellerForcedCompleteDate = orderDetails.getTimestamp(69)
		def sellerForcedCompleteDateUTC
		if(sellerForcedCompleteDate != null) {
			sellerForcedCompleteDate = sellerForcedCompleteDate.format("yyyy-MM-dd'T'HH:mm:ss")
			sellerForcedCompleteDateUTC = orderDetails.getTimestamp(69).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def orderAcknowledgeDate = orderDetails.getTimestamp(70)
		def orderAcknowledgeDateUTC
		if(orderAcknowledgeDate != null) {
			orderAcknowledgeDate = orderAcknowledgeDate.format("yyyy-MM-dd'T'HH:mm:ss")
			orderAcknowledgeDateUTC = orderDetails.getTimestamp(70).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def abandonedDate = orderDetails.getTimestamp(71)
		def abandonedDateUTC
		if(abandonedDate != null) {
			abandonedDate = abandonedDate.format("yyyy-MM-dd'T'HH:mm:ss")
			abandonedDateUTC = orderDetails.getTimestamp(77).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))
		}

		def lastModifiedDate = orderDetails.getTimestamp(72).format("yyyy-MM-dd'T'HH:mm:ss")
		def lastModifiedDateUTC = orderDetails.getTimestamp(72).format("yyyy-MM-dd'T'HH:mm:ss'Z'", TimeZone.getTimeZone("UTC"))


		def isTaxExempt = orderDetails.getBoolean(73)
		def buyerFeeID = orderDetails.getString(74)

		def itemTitle = orderDetails.getString(75)
		def itemQuantity = orderDetails.getInt(76)
		def itemPrice = orderDetails.getBigDecimal(77).setScale(2, BigDecimal.ROUND_HALF_UP)
		def itemTaxRate = orderDetails.getBigDecimal(78).setScale(2, BigDecimal.ROUND_HALF_UP)
		def isFFLRequired = orderDetails.getBoolean(79)
		def itemID = orderDetails.getInt(80)
		def itemWeight = orderDetails.getBigDecimal(81)
		def itemWeightUnit = orderDetails.getString(82)
		def itemShippingProfileID = orderDetails.getInt(83)
		def itemFixedPrice = orderDetails.getBigDecimal(84).setScale(2, BigDecimal.ROUND_HALF_UP)
		def itemSKU = orderDetails.getString(85)
		def itemUPC = orderDetails.getString(86)
		def itemSerialNumber = orderDetails.getString(87)
		def itemGSIN = orderDetails.getString(88)
		def itemShipTerms = orderDetails.getInt(89)
		def salesTaxTotal = orderDetails.getBigDecimal(90).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxInsTotal = orderDetails.getBigDecimal(91).setScale(2, BigDecimal.ROUND_HALF_UP)
		def salesTaxHandling = orderDetails.getBigDecimal(92).setScale(2, BigDecimal.ROUND_HALF_UP)
		def itemGTIN = orderDetails.getString(93)
		def itemCondition = orderDetails.getString(94)
		if(itemCondition == '1') {
			itemCondition = 'Factory New'
		}
		else if (itemCondition == '2') {
			itemCondition = 'New Old Stock'
		}
		else if (itemCondition == '3') {
			itemCondition = 'Used'
		}
		else (KeywordUtil.markError('Invalid in DB for item condition'))

		def shipTrackingNumber = orderDetails.getString(95)
		def itemThumbnail = orderDetails.getString(96)

		def hasSellerLeftFeedback = orderDetails.getBoolean(97)
		def hasBuyerLeftFeedback = orderDetails.getBoolean(98)

		//Handle Order Total when Status = 6
		if(status == 6) {orderTotal = ((itemPrice * itemQuantity) * (itemTaxRate/100)) + complianceFee + itemPrice
			orderTotal = orderTotal.setScale(2, BigDecimal.ROUND_HALF_UP)
		}


		sql_Server.closeDatabaseConnection()




		orderObject.put('orderID', orderID)
		orderObject.put('buyerID', buyerID)
		orderObject.put('sellerID', sellerID)
		orderObject.put('orderStatus', status)
		orderObject.put('fflNumber', fflNumber)
		orderObject.put('isItemInsured', isItemInsured)
		orderObject.put('couponID', couponID)
		orderObject.put('couponCode', couponCode)
		orderObject.put('couponValue', couponValue)
		orderObject.put('shipCarrier', shipCarrier)
		orderObject.put('shipFromCompany', shipFromCompany)
		orderObject.put('shipToVerified', shipToVerified)
		orderObject.put('shipClass', shipClass)
		orderObject.put('taxCloudCartID', taxCloudCartID)
		orderObject.put('miscDesc', miscDesc)
		orderObject.put('paymentMethod', paymentMethod)
		orderObject.put('billToName', billToName)
		orderObject.put('billToAddress1', billToAddress1)
		orderObject.put('billToAddress2', billToAddress2)
		orderObject.put('billToCity', billToCity)
		orderObject.put('billToState', billToState)
		orderObject.put('billToPostalCode', billToPostalCode)
		orderObject.put('billToCountryCode', billToCountryCode)
		orderObject.put('billToPhone', billToPhone)
		orderObject.put('billToEmail', billToEmail)

		orderObject.put('shipToName', shipToName)
		orderObject.put('shipToAddress1', shipToAddress1)
		orderObject.put('shipToAddress2', shipToAddress2)
		orderObject.put('shipToCity', shipToCity)
		orderObject.put('shipToState', shipToState)
		orderObject.put('shipToPostalCode', shipToPostalCode)
		orderObject.put('shipToCountryCode', shipToCountryCode)
		orderObject.put('shipToPhone', shipToPhone)
		orderObject.put('shipToEmail', shipToEmail)

		orderObject.put('shipFromName', shipFromName)
		orderObject.put('shipFromAddress1', shipFromAddress1)
		orderObject.put('shipFromAddress2', shipFromAddress2)
		orderObject.put('shipFromCity', shipFromCity)
		orderObject.put('shipFromState', shipFromState)
		orderObject.put('shipFromPostalCode', shipFromPostalCode)
		orderObject.put('shipFromCountryCode', shipFromCountryCode)
		orderObject.put('shipFromPhone', shipFromPhone)
		orderObject.put('shipFromEmail', shipFromEmail)

		orderObject.put('shipCost', shipCost)
		orderObject.put('shipHandlingCost', shipHandlingCost)
		orderObject.put('shipInsuranceCost', shipInsuranceCost)
		orderObject.put('shipTrackingNumber', shipTrackingNumber)
		orderObject.put('orderTotal', orderTotal)
		orderObject.put('ccUpChargePercent', ccUpChargePercent)
		orderObject.put('salesTaxShipping', salesTaxShipping)
		orderObject.put('salesTaxInsurance', salesTaxInsurance)
		orderObject.put('salesTaxMisc', salesTaxMisc)
		orderObject.put('salesTaxShippingTotal', salesTaxShippingTotal)
		orderObject.put('salesTaxHandlingTotal', salesTaxHandlingTotal)
		orderObject.put('salesTaxMiscTotal', salesTaxMiscTotal)
		orderObject.put('salesTaxInsTotal', salesTaxInsTotal)
		orderObject.put('salesTaxHandling', salesTaxHandling)
		orderObject.put('salesTaxTotal', salesTaxTotal)
		orderObject.put('cashDiscTotal', cashDiscTotal)
		orderObject.put('complianceFee', complianceFee)
		orderObject.put('miscCharge', miscCharge)
		orderObject.put('orderDate', orderDate)
		orderObject.put('orderDateUTC', orderDateUTC)
		orderObject.put('cancelDate', cancelDate)
		orderObject.put('cancelDateUTC', cancelDateUTC)
		orderObject.put('layawayAcceptanceDate', layawayAcceptanceDate)
		orderObject.put('layawayAcceptanceDateUTC', layawayAcceptanceDateUTC)
		orderObject.put('sellerReviewDate', sellerReviewDate)
		orderObject.put('sellerReviewDateUTC', sellerReviewDateUTC)
		orderObject.put('buyerConfirmationDate', buyerConfirmationDate)
		orderObject.put('buyerConfirmationDateUTC', buyerConfirmationDateUTC)
		orderObject.put('paymentReceivedDate', paymentReceivedDate)
		orderObject.put('paymentReceivedDateUTC', paymentReceivedDateUTC)
		orderObject.put('fflReceivedDate', fflReceivedDate)
		orderObject.put('fflReceivedDateUTC', fflReceivedDateUTC)
		orderObject.put('shipDate', shipDate)
		orderObject.put('shipDateUTC', shipDateUTC)
		orderObject.put('paymentInProcessDate', paymentInProcessDate)
		orderObject.put('paymentInProcessDateUTC', paymentInProcessDateUTC)
		orderObject.put('returnedDate', returnedDate)
		orderObject.put('returnedDateUTC', returnedDateUTC)
		orderObject.put('buyerReviewedDate', buyerReviewedDate)
		orderObject.put('buyerReviewedDateUTC', buyerReviewedDateUTC)
		orderObject.put('sellerForcedCompleteDate', sellerForcedCompleteDate)
		orderObject.put('sellerForcedCompleteDateUTC', sellerForcedCompleteDateUTC)
		orderObject.put('orderAcknowledgeDate', orderAcknowledgeDate)
		orderObject.put('orderAcknowledgeDateUTC', orderAcknowledgeDateUTC)
		orderObject.put('abandonedDate', abandonedDate)
		orderObject.put('abandonedDateUTC', abandonedDateUTC)
		orderObject.put('lastModifiedDate', lastModifiedDate)
		orderObject.put('lastModifiedDateUTC', lastModifiedDateUTC)
		orderObject.put('isTaxExempt', isTaxExempt)
		orderObject.put('buyerFeeID', buyerFeeID)
		orderObject.put('itemTitle', itemTitle)
		orderObject.put('itemQuantity', itemQuantity)
		orderObject.put('itemPrice', itemPrice)
		orderObject.put('itemTaxRate', itemTaxRate)
		orderObject.put('isFFLRequired', isFFLRequired)
		orderObject.put('itemID', itemID)
		orderObject.put('itemWeight', itemWeight)
		orderObject.put('itemWeightUnit', itemWeightUnit)
		orderObject.put('itemShippingProfileID', itemShippingProfileID)
		orderObject.put('itemFixedPrice', itemFixedPrice)
		orderObject.put('itemSKU', itemSKU)
		orderObject.put('itemUPC', itemUPC)
		orderObject.put('itemSerialNumber', itemSerialNumber)
		orderObject.put('itemGSIN', itemGSIN)
		orderObject.put('itemGTIN', itemGTIN)
		orderObject.put('itemShipTerms', itemShipTerms)
		orderObject.put('itemCondition', itemCondition)
		orderObject.put('itemThumbnail', itemThumbnail)

		orderObject.put('hasSellerLeftFeedback', hasSellerLeftFeedback)
		orderObject.put('hasBuyerLeftFeedback', hasBuyerLeftFeedback)


		return orderObject;
	}
}
